#include <stdio.h>
#include<stdlib.h>
#include<math.h>
#include"SimpleImage.h"
#include"pgmio.h"
#include"otsu.h"
#include"thinning.h"


double getVal0to255(double val){
  int vali =((int)(((double)(255.0*val))));
  if(fabs((double)(val-vali))>=0.5)vali++;
  if(vali<0)vali=0;
  if(vali>255)vali=255;
  return ((double)(vali));
}


int main(int argc, char* argv[])
{
  Image *in = new Image();

  getPGM(in,argv[1]);
  
  Image *out = new Image(in->sx,in->sy);
  
  /* main processing */
  int i,j;

  int HISTSIZE=256;
  Otsu *myotsu = new Otsu(HISTSIZE);

  double threshold = ((double)(myotsu->find_otsu_threshold(in)));
  printf("Otsu's threshold value = %lf\n",threshold);
  delete myotsu;
  double WhiteLABEL=255.0;
  for(i=0;i<in->sy;i++)
    for(j=0;j<in->sx;j++){
      if(in->img[i][j]>=threshold){
	out->img[i][j] = 0.0;
      }else{
	out->img[i][j] = WhiteLABEL;
      }
    }
  
  //thinning
  
  thinning(out,WhiteLABEL);  

  /* end main processing */

  
  savePGM(out,argv[2]);


  delete out;
  delete in;
  
  return 0;
}
